/*
 * Copyright (C) 2010-2011 Daniel Richter <danielrichter2007@web.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
 */

#ifndef COMMONCLASS_H_
#define COMMONCLASS_H_
#include "../lib/Logger.h"
#include "Exception.h"

class CommonClass {
	mutable Logger* logger;
	std::string _controllerName;
public:
	CommonClass();
	void setLogger(Logger& logger);
	Logger const& getLogger() const;
	Logger& getLogger();
	Logger* getLoggerPtr();
	bool hasLogger() const;
protected:
	void setControllerName(std::string const& name);
	void log(std::string const& message, Logger::Priority prio) const;
	void logActionBegin(std::string const& action) const;
	void logActionEnd() const;
	void logActionBeginThreaded(std::string const& action) const;
	void logActionEndThreaded() const;
};

#endif
